// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: kv_rpc.proto

package org.apache.bookkeeper.stream.proto.kv.rpc;

/**
 * <pre>
 * From google paxosdb paper:
 * Our implementation hinges around a powerful primitive which we call MultiOp. All other database
 * operations except for iteration are implemented as a single call to MultiOp. A MultiOp is applied atomically
 * and consists of three components:
 * 1. A list of tests called guard. Each test in guard checks a single entry in the database. It may check
 * for the absence or presence of a value, or compare with a given value. Two different tests in the guard
 * may apply to the same or different entries in the database. All tests in the guard are applied and
 * MultiOp returns the results. If all tests are true, MultiOp executes t op (see item 2 below), otherwise
 * it executes f op (see item 3 below).
 * 2. A list of database operations called t op. Each operation in the list is either an insert, delete, or
 * lookup operation, and applies to a single database entry. Two different operations in the list may apply
 * to the same or different entries in the database. These operations are executed
 * if guard evaluates to
 * true.
 * 3. A list of database operations called f op. Like t op, but executed if guard evaluates to false.
 * </pre>
 *
 * Protobuf type {@code bookkeeper.proto.kv.rpc.TxnRequest}
 */
public final class TxnRequest extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:bookkeeper.proto.kv.rpc.TxnRequest)
    TxnRequestOrBuilder {
private static final long serialVersionUID = 0L;
  // Use TxnRequest.newBuilder() to construct.
  private TxnRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private TxnRequest() {
    compare_ = java.util.Collections.emptyList();
    success_ = java.util.Collections.emptyList();
    failure_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new TxnRequest();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private TxnRequest(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            if (!((mutable_bitField0_ & 0x00000001) != 0)) {
              compare_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.Compare>();
              mutable_bitField0_ |= 0x00000001;
            }
            compare_.add(
                input.readMessage(org.apache.bookkeeper.stream.proto.kv.rpc.Compare.parser(), extensionRegistry));
            break;
          }
          case 18: {
            if (!((mutable_bitField0_ & 0x00000002) != 0)) {
              success_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp>();
              mutable_bitField0_ |= 0x00000002;
            }
            success_.add(
                input.readMessage(org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.parser(), extensionRegistry));
            break;
          }
          case 26: {
            if (!((mutable_bitField0_ & 0x00000004) != 0)) {
              failure_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp>();
              mutable_bitField0_ |= 0x00000004;
            }
            failure_.add(
                input.readMessage(org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.parser(), extensionRegistry));
            break;
          }
          case 794: {
            org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder subBuilder = null;
            if (header_ != null) {
              subBuilder = header_.toBuilder();
            }
            header_ = input.readMessage(org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(header_);
              header_ = subBuilder.buildPartial();
            }

            break;
          }
          default: {
            if (!parseUnknownField(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        compare_ = java.util.Collections.unmodifiableList(compare_);
      }
      if (((mutable_bitField0_ & 0x00000002) != 0)) {
        success_ = java.util.Collections.unmodifiableList(success_);
      }
      if (((mutable_bitField0_ & 0x00000004) != 0)) {
        failure_ = java.util.Collections.unmodifiableList(failure_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return org.apache.bookkeeper.stream.proto.kv.rpc.KvRpc.internal_static_bookkeeper_proto_kv_rpc_TxnRequest_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.bookkeeper.stream.proto.kv.rpc.KvRpc.internal_static_bookkeeper_proto_kv_rpc_TxnRequest_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.class, org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.Builder.class);
  }

  public static final int COMPARE_FIELD_NUMBER = 1;
  private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.Compare> compare_;
  /**
   * <pre>
   * compare is a list of predicates representing a conjunction of terms.
   * If the comparisons succeed, then the success requests will be processed in order,
   * and the response will contain their respective responses in order.
   * If the comparisons fail, then the failure requests will be processed in order,
   * and the response will contain their respective responses in order.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.Compare> getCompareList() {
    return compare_;
  }
  /**
   * <pre>
   * compare is a list of predicates representing a conjunction of terms.
   * If the comparisons succeed, then the success requests will be processed in order,
   * and the response will contain their respective responses in order.
   * If the comparisons fail, then the failure requests will be processed in order,
   * and the response will contain their respective responses in order.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder> 
      getCompareOrBuilderList() {
    return compare_;
  }
  /**
   * <pre>
   * compare is a list of predicates representing a conjunction of terms.
   * If the comparisons succeed, then the success requests will be processed in order,
   * and the response will contain their respective responses in order.
   * If the comparisons fail, then the failure requests will be processed in order,
   * and the response will contain their respective responses in order.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
   */
  @java.lang.Override
  public int getCompareCount() {
    return compare_.size();
  }
  /**
   * <pre>
   * compare is a list of predicates representing a conjunction of terms.
   * If the comparisons succeed, then the success requests will be processed in order,
   * and the response will contain their respective responses in order.
   * If the comparisons fail, then the failure requests will be processed in order,
   * and the response will contain their respective responses in order.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.Compare getCompare(int index) {
    return compare_.get(index);
  }
  /**
   * <pre>
   * compare is a list of predicates representing a conjunction of terms.
   * If the comparisons succeed, then the success requests will be processed in order,
   * and the response will contain their respective responses in order.
   * If the comparisons fail, then the failure requests will be processed in order,
   * and the response will contain their respective responses in order.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder getCompareOrBuilder(
      int index) {
    return compare_.get(index);
  }

  public static final int SUCCESS_FIELD_NUMBER = 2;
  private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> success_;
  /**
   * <pre>
   * success is a list of requests which will be applied when compare evaluates to true.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> getSuccessList() {
    return success_;
  }
  /**
   * <pre>
   * success is a list of requests which will be applied when compare evaluates to true.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
      getSuccessOrBuilderList() {
    return success_;
  }
  /**
   * <pre>
   * success is a list of requests which will be applied when compare evaluates to true.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
   */
  @java.lang.Override
  public int getSuccessCount() {
    return success_.size();
  }
  /**
   * <pre>
   * success is a list of requests which will be applied when compare evaluates to true.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp getSuccess(int index) {
    return success_.get(index);
  }
  /**
   * <pre>
   * success is a list of requests which will be applied when compare evaluates to true.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder getSuccessOrBuilder(
      int index) {
    return success_.get(index);
  }

  public static final int FAILURE_FIELD_NUMBER = 3;
  private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> failure_;
  /**
   * <pre>
   * failure is a list of requests which will be applied when compare evaluates to false.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> getFailureList() {
    return failure_;
  }
  /**
   * <pre>
   * failure is a list of requests which will be applied when compare evaluates to false.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
      getFailureOrBuilderList() {
    return failure_;
  }
  /**
   * <pre>
   * failure is a list of requests which will be applied when compare evaluates to false.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
   */
  @java.lang.Override
  public int getFailureCount() {
    return failure_.size();
  }
  /**
   * <pre>
   * failure is a list of requests which will be applied when compare evaluates to false.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp getFailure(int index) {
    return failure_.get(index);
  }
  /**
   * <pre>
   * failure is a list of requests which will be applied when compare evaluates to false.
   * </pre>
   *
   * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder getFailureOrBuilder(
      int index) {
    return failure_.get(index);
  }

  public static final int HEADER_FIELD_NUMBER = 99;
  private org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader header_;
  /**
   * <pre>
   * header
   * </pre>
   *
   * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
   * @return Whether the header field is set.
   */
  @java.lang.Override
  public boolean hasHeader() {
    return header_ != null;
  }
  /**
   * <pre>
   * header
   * </pre>
   *
   * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
   * @return The header.
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader getHeader() {
    return header_ == null ? org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.getDefaultInstance() : header_;
  }
  /**
   * <pre>
   * header
   * </pre>
   *
   * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
   */
  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeaderOrBuilder getHeaderOrBuilder() {
    return getHeader();
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < compare_.size(); i++) {
      output.writeMessage(1, compare_.get(i));
    }
    for (int i = 0; i < success_.size(); i++) {
      output.writeMessage(2, success_.get(i));
    }
    for (int i = 0; i < failure_.size(); i++) {
      output.writeMessage(3, failure_.get(i));
    }
    if (header_ != null) {
      output.writeMessage(99, getHeader());
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < compare_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, compare_.get(i));
    }
    for (int i = 0; i < success_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, success_.get(i));
    }
    for (int i = 0; i < failure_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, failure_.get(i));
    }
    if (header_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(99, getHeader());
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest)) {
      return super.equals(obj);
    }
    org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest other = (org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest) obj;

    if (!getCompareList()
        .equals(other.getCompareList())) return false;
    if (!getSuccessList()
        .equals(other.getSuccessList())) return false;
    if (!getFailureList()
        .equals(other.getFailureList())) return false;
    if (hasHeader() != other.hasHeader()) return false;
    if (hasHeader()) {
      if (!getHeader()
          .equals(other.getHeader())) return false;
    }
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getCompareCount() > 0) {
      hash = (37 * hash) + COMPARE_FIELD_NUMBER;
      hash = (53 * hash) + getCompareList().hashCode();
    }
    if (getSuccessCount() > 0) {
      hash = (37 * hash) + SUCCESS_FIELD_NUMBER;
      hash = (53 * hash) + getSuccessList().hashCode();
    }
    if (getFailureCount() > 0) {
      hash = (37 * hash) + FAILURE_FIELD_NUMBER;
      hash = (53 * hash) + getFailureList().hashCode();
    }
    if (hasHeader()) {
      hash = (37 * hash) + HEADER_FIELD_NUMBER;
      hash = (53 * hash) + getHeader().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * From google paxosdb paper:
   * Our implementation hinges around a powerful primitive which we call MultiOp. All other database
   * operations except for iteration are implemented as a single call to MultiOp. A MultiOp is applied atomically
   * and consists of three components:
   * 1. A list of tests called guard. Each test in guard checks a single entry in the database. It may check
   * for the absence or presence of a value, or compare with a given value. Two different tests in the guard
   * may apply to the same or different entries in the database. All tests in the guard are applied and
   * MultiOp returns the results. If all tests are true, MultiOp executes t op (see item 2 below), otherwise
   * it executes f op (see item 3 below).
   * 2. A list of database operations called t op. Each operation in the list is either an insert, delete, or
   * lookup operation, and applies to a single database entry. Two different operations in the list may apply
   * to the same or different entries in the database. These operations are executed
   * if guard evaluates to
   * true.
   * 3. A list of database operations called f op. Like t op, but executed if guard evaluates to false.
   * </pre>
   *
   * Protobuf type {@code bookkeeper.proto.kv.rpc.TxnRequest}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:bookkeeper.proto.kv.rpc.TxnRequest)
      org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequestOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.bookkeeper.stream.proto.kv.rpc.KvRpc.internal_static_bookkeeper_proto_kv_rpc_TxnRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.bookkeeper.stream.proto.kv.rpc.KvRpc.internal_static_bookkeeper_proto_kv_rpc_TxnRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.class, org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.Builder.class);
    }

    // Construct using org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getCompareFieldBuilder();
        getSuccessFieldBuilder();
        getFailureFieldBuilder();
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (compareBuilder_ == null) {
        compare_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        compareBuilder_.clear();
      }
      if (successBuilder_ == null) {
        success_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        successBuilder_.clear();
      }
      if (failureBuilder_ == null) {
        failure_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
      } else {
        failureBuilder_.clear();
      }
      if (headerBuilder_ == null) {
        header_ = null;
      } else {
        header_ = null;
        headerBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return org.apache.bookkeeper.stream.proto.kv.rpc.KvRpc.internal_static_bookkeeper_proto_kv_rpc_TxnRequest_descriptor;
    }

    @java.lang.Override
    public org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest getDefaultInstanceForType() {
      return org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest build() {
      org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest buildPartial() {
      org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest result = new org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest(this);
      int from_bitField0_ = bitField0_;
      if (compareBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          compare_ = java.util.Collections.unmodifiableList(compare_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.compare_ = compare_;
      } else {
        result.compare_ = compareBuilder_.build();
      }
      if (successBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)) {
          success_ = java.util.Collections.unmodifiableList(success_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.success_ = success_;
      } else {
        result.success_ = successBuilder_.build();
      }
      if (failureBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0)) {
          failure_ = java.util.Collections.unmodifiableList(failure_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.failure_ = failure_;
      } else {
        result.failure_ = failureBuilder_.build();
      }
      if (headerBuilder_ == null) {
        result.header_ = header_;
      } else {
        result.header_ = headerBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest) {
        return mergeFrom((org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest other) {
      if (other == org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest.getDefaultInstance()) return this;
      if (compareBuilder_ == null) {
        if (!other.compare_.isEmpty()) {
          if (compare_.isEmpty()) {
            compare_ = other.compare_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureCompareIsMutable();
            compare_.addAll(other.compare_);
          }
          onChanged();
        }
      } else {
        if (!other.compare_.isEmpty()) {
          if (compareBuilder_.isEmpty()) {
            compareBuilder_.dispose();
            compareBuilder_ = null;
            compare_ = other.compare_;
            bitField0_ = (bitField0_ & ~0x00000001);
            compareBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getCompareFieldBuilder() : null;
          } else {
            compareBuilder_.addAllMessages(other.compare_);
          }
        }
      }
      if (successBuilder_ == null) {
        if (!other.success_.isEmpty()) {
          if (success_.isEmpty()) {
            success_ = other.success_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureSuccessIsMutable();
            success_.addAll(other.success_);
          }
          onChanged();
        }
      } else {
        if (!other.success_.isEmpty()) {
          if (successBuilder_.isEmpty()) {
            successBuilder_.dispose();
            successBuilder_ = null;
            success_ = other.success_;
            bitField0_ = (bitField0_ & ~0x00000002);
            successBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getSuccessFieldBuilder() : null;
          } else {
            successBuilder_.addAllMessages(other.success_);
          }
        }
      }
      if (failureBuilder_ == null) {
        if (!other.failure_.isEmpty()) {
          if (failure_.isEmpty()) {
            failure_ = other.failure_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureFailureIsMutable();
            failure_.addAll(other.failure_);
          }
          onChanged();
        }
      } else {
        if (!other.failure_.isEmpty()) {
          if (failureBuilder_.isEmpty()) {
            failureBuilder_.dispose();
            failureBuilder_ = null;
            failure_ = other.failure_;
            bitField0_ = (bitField0_ & ~0x00000004);
            failureBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getFailureFieldBuilder() : null;
          } else {
            failureBuilder_.addAllMessages(other.failure_);
          }
        }
      }
      if (other.hasHeader()) {
        mergeHeader(other.getHeader());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.Compare> compare_ =
      java.util.Collections.emptyList();
    private void ensureCompareIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        compare_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.Compare>(compare_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.Compare, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder> compareBuilder_;

    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.Compare> getCompareList() {
      if (compareBuilder_ == null) {
        return java.util.Collections.unmodifiableList(compare_);
      } else {
        return compareBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public int getCompareCount() {
      if (compareBuilder_ == null) {
        return compare_.size();
      } else {
        return compareBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.Compare getCompare(int index) {
      if (compareBuilder_ == null) {
        return compare_.get(index);
      } else {
        return compareBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder setCompare(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.Compare value) {
      if (compareBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCompareIsMutable();
        compare_.set(index, value);
        onChanged();
      } else {
        compareBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder setCompare(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder builderForValue) {
      if (compareBuilder_ == null) {
        ensureCompareIsMutable();
        compare_.set(index, builderForValue.build());
        onChanged();
      } else {
        compareBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder addCompare(org.apache.bookkeeper.stream.proto.kv.rpc.Compare value) {
      if (compareBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCompareIsMutable();
        compare_.add(value);
        onChanged();
      } else {
        compareBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder addCompare(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.Compare value) {
      if (compareBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCompareIsMutable();
        compare_.add(index, value);
        onChanged();
      } else {
        compareBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder addCompare(
        org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder builderForValue) {
      if (compareBuilder_ == null) {
        ensureCompareIsMutable();
        compare_.add(builderForValue.build());
        onChanged();
      } else {
        compareBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder addCompare(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder builderForValue) {
      if (compareBuilder_ == null) {
        ensureCompareIsMutable();
        compare_.add(index, builderForValue.build());
        onChanged();
      } else {
        compareBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder addAllCompare(
        java.lang.Iterable<? extends org.apache.bookkeeper.stream.proto.kv.rpc.Compare> values) {
      if (compareBuilder_ == null) {
        ensureCompareIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, compare_);
        onChanged();
      } else {
        compareBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder clearCompare() {
      if (compareBuilder_ == null) {
        compare_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        compareBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public Builder removeCompare(int index) {
      if (compareBuilder_ == null) {
        ensureCompareIsMutable();
        compare_.remove(index);
        onChanged();
      } else {
        compareBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder getCompareBuilder(
        int index) {
      return getCompareFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder getCompareOrBuilder(
        int index) {
      if (compareBuilder_ == null) {
        return compare_.get(index);  } else {
        return compareBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder> 
         getCompareOrBuilderList() {
      if (compareBuilder_ != null) {
        return compareBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(compare_);
      }
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder addCompareBuilder() {
      return getCompareFieldBuilder().addBuilder(
          org.apache.bookkeeper.stream.proto.kv.rpc.Compare.getDefaultInstance());
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder addCompareBuilder(
        int index) {
      return getCompareFieldBuilder().addBuilder(
          index, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.getDefaultInstance());
    }
    /**
     * <pre>
     * compare is a list of predicates representing a conjunction of terms.
     * If the comparisons succeed, then the success requests will be processed in order,
     * and the response will contain their respective responses in order.
     * If the comparisons fail, then the failure requests will be processed in order,
     * and the response will contain their respective responses in order.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.Compare compare = 1;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder> 
         getCompareBuilderList() {
      return getCompareFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.Compare, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder> 
        getCompareFieldBuilder() {
      if (compareBuilder_ == null) {
        compareBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.bookkeeper.stream.proto.kv.rpc.Compare, org.apache.bookkeeper.stream.proto.kv.rpc.Compare.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.CompareOrBuilder>(
                compare_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        compare_ = null;
      }
      return compareBuilder_;
    }

    private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> success_ =
      java.util.Collections.emptyList();
    private void ensureSuccessIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        success_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp>(success_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> successBuilder_;

    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> getSuccessList() {
      if (successBuilder_ == null) {
        return java.util.Collections.unmodifiableList(success_);
      } else {
        return successBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public int getSuccessCount() {
      if (successBuilder_ == null) {
        return success_.size();
      } else {
        return successBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp getSuccess(int index) {
      if (successBuilder_ == null) {
        return success_.get(index);
      } else {
        return successBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder setSuccess(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (successBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSuccessIsMutable();
        success_.set(index, value);
        onChanged();
      } else {
        successBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder setSuccess(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (successBuilder_ == null) {
        ensureSuccessIsMutable();
        success_.set(index, builderForValue.build());
        onChanged();
      } else {
        successBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder addSuccess(org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (successBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSuccessIsMutable();
        success_.add(value);
        onChanged();
      } else {
        successBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder addSuccess(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (successBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSuccessIsMutable();
        success_.add(index, value);
        onChanged();
      } else {
        successBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder addSuccess(
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (successBuilder_ == null) {
        ensureSuccessIsMutable();
        success_.add(builderForValue.build());
        onChanged();
      } else {
        successBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder addSuccess(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (successBuilder_ == null) {
        ensureSuccessIsMutable();
        success_.add(index, builderForValue.build());
        onChanged();
      } else {
        successBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder addAllSuccess(
        java.lang.Iterable<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> values) {
      if (successBuilder_ == null) {
        ensureSuccessIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, success_);
        onChanged();
      } else {
        successBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder clearSuccess() {
      if (successBuilder_ == null) {
        success_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        successBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public Builder removeSuccess(int index) {
      if (successBuilder_ == null) {
        ensureSuccessIsMutable();
        success_.remove(index);
        onChanged();
      } else {
        successBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder getSuccessBuilder(
        int index) {
      return getSuccessFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder getSuccessOrBuilder(
        int index) {
      if (successBuilder_ == null) {
        return success_.get(index);  } else {
        return successBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
         getSuccessOrBuilderList() {
      if (successBuilder_ != null) {
        return successBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(success_);
      }
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder addSuccessBuilder() {
      return getSuccessFieldBuilder().addBuilder(
          org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.getDefaultInstance());
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder addSuccessBuilder(
        int index) {
      return getSuccessFieldBuilder().addBuilder(
          index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.getDefaultInstance());
    }
    /**
     * <pre>
     * success is a list of requests which will be applied when compare evaluates to true.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp success = 2;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder> 
         getSuccessBuilderList() {
      return getSuccessFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
        getSuccessFieldBuilder() {
      if (successBuilder_ == null) {
        successBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder>(
                success_,
                ((bitField0_ & 0x00000002) != 0),
                getParentForChildren(),
                isClean());
        success_ = null;
      }
      return successBuilder_;
    }

    private java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> failure_ =
      java.util.Collections.emptyList();
    private void ensureFailureIsMutable() {
      if (!((bitField0_ & 0x00000004) != 0)) {
        failure_ = new java.util.ArrayList<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp>(failure_);
        bitField0_ |= 0x00000004;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> failureBuilder_;

    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> getFailureList() {
      if (failureBuilder_ == null) {
        return java.util.Collections.unmodifiableList(failure_);
      } else {
        return failureBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public int getFailureCount() {
      if (failureBuilder_ == null) {
        return failure_.size();
      } else {
        return failureBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp getFailure(int index) {
      if (failureBuilder_ == null) {
        return failure_.get(index);
      } else {
        return failureBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder setFailure(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (failureBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFailureIsMutable();
        failure_.set(index, value);
        onChanged();
      } else {
        failureBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder setFailure(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (failureBuilder_ == null) {
        ensureFailureIsMutable();
        failure_.set(index, builderForValue.build());
        onChanged();
      } else {
        failureBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder addFailure(org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (failureBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFailureIsMutable();
        failure_.add(value);
        onChanged();
      } else {
        failureBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder addFailure(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp value) {
      if (failureBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFailureIsMutable();
        failure_.add(index, value);
        onChanged();
      } else {
        failureBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder addFailure(
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (failureBuilder_ == null) {
        ensureFailureIsMutable();
        failure_.add(builderForValue.build());
        onChanged();
      } else {
        failureBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder addFailure(
        int index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder builderForValue) {
      if (failureBuilder_ == null) {
        ensureFailureIsMutable();
        failure_.add(index, builderForValue.build());
        onChanged();
      } else {
        failureBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder addAllFailure(
        java.lang.Iterable<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp> values) {
      if (failureBuilder_ == null) {
        ensureFailureIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, failure_);
        onChanged();
      } else {
        failureBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder clearFailure() {
      if (failureBuilder_ == null) {
        failure_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        failureBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public Builder removeFailure(int index) {
      if (failureBuilder_ == null) {
        ensureFailureIsMutable();
        failure_.remove(index);
        onChanged();
      } else {
        failureBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder getFailureBuilder(
        int index) {
      return getFailureFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder getFailureOrBuilder(
        int index) {
      if (failureBuilder_ == null) {
        return failure_.get(index);  } else {
        return failureBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public java.util.List<? extends org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
         getFailureOrBuilderList() {
      if (failureBuilder_ != null) {
        return failureBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(failure_);
      }
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder addFailureBuilder() {
      return getFailureFieldBuilder().addBuilder(
          org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.getDefaultInstance());
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder addFailureBuilder(
        int index) {
      return getFailureFieldBuilder().addBuilder(
          index, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.getDefaultInstance());
    }
    /**
     * <pre>
     * failure is a list of requests which will be applied when compare evaluates to false.
     * </pre>
     *
     * <code>repeated .bookkeeper.proto.kv.rpc.RequestOp failure = 3;</code>
     */
    public java.util.List<org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder> 
         getFailureBuilderList() {
      return getFailureFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder> 
        getFailureFieldBuilder() {
      if (failureBuilder_ == null) {
        failureBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOp.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RequestOpOrBuilder>(
                failure_,
                ((bitField0_ & 0x00000004) != 0),
                getParentForChildren(),
                isClean());
        failure_ = null;
      }
      return failureBuilder_;
    }

    private org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader header_;
    private com.google.protobuf.SingleFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeaderOrBuilder> headerBuilder_;
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     * @return Whether the header field is set.
     */
    public boolean hasHeader() {
      return headerBuilder_ != null || header_ != null;
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     * @return The header.
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader getHeader() {
      if (headerBuilder_ == null) {
        return header_ == null ? org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.getDefaultInstance() : header_;
      } else {
        return headerBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public Builder setHeader(org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader value) {
      if (headerBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        header_ = value;
        onChanged();
      } else {
        headerBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public Builder setHeader(
        org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder builderForValue) {
      if (headerBuilder_ == null) {
        header_ = builderForValue.build();
        onChanged();
      } else {
        headerBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public Builder mergeHeader(org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader value) {
      if (headerBuilder_ == null) {
        if (header_ != null) {
          header_ =
            org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.newBuilder(header_).mergeFrom(value).buildPartial();
        } else {
          header_ = value;
        }
        onChanged();
      } else {
        headerBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public Builder clearHeader() {
      if (headerBuilder_ == null) {
        header_ = null;
        onChanged();
      } else {
        header_ = null;
        headerBuilder_ = null;
      }

      return this;
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder getHeaderBuilder() {
      
      onChanged();
      return getHeaderFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    public org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeaderOrBuilder getHeaderOrBuilder() {
      if (headerBuilder_ != null) {
        return headerBuilder_.getMessageOrBuilder();
      } else {
        return header_ == null ?
            org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.getDefaultInstance() : header_;
      }
    }
    /**
     * <pre>
     * header
     * </pre>
     *
     * <code>.bookkeeper.proto.kv.rpc.RoutingHeader header = 99;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeaderOrBuilder> 
        getHeaderFieldBuilder() {
      if (headerBuilder_ == null) {
        headerBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeader.Builder, org.apache.bookkeeper.stream.proto.kv.rpc.RoutingHeaderOrBuilder>(
                getHeader(),
                getParentForChildren(),
                isClean());
        header_ = null;
      }
      return headerBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:bookkeeper.proto.kv.rpc.TxnRequest)
  }

  // @@protoc_insertion_point(class_scope:bookkeeper.proto.kv.rpc.TxnRequest)
  private static final org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest();
  }

  public static org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<TxnRequest>
      PARSER = new com.google.protobuf.AbstractParser<TxnRequest>() {
    @java.lang.Override
    public TxnRequest parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new TxnRequest(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<TxnRequest> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<TxnRequest> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.bookkeeper.stream.proto.kv.rpc.TxnRequest getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

